@echo off
rem
rem  These are the command line parameters for AViewCom included here for
rem  your convenience.  You may delete the remark lines if you wish.
rem
rem AViewCom archive [port] [options]
rem   archive  = file to view, or '*' to search
rem   port     = 'com#' or 'local' where # = 0 to 22 and 0 = local
rem options:
rem   -a#      = ansi: 0 = mono, 1 = ansi, 2 = prompt user
rem   -b#      = com port base address in hex
rem   -c       = read options from configuration file
rem   -d       = do not allow downloading
rem   -e#      = extractor:  0-pkxarc,  1-pkunpak, 2-pak,  3-arc,
rem                          4-pkunzip, 5-zoo,     6-lha   7-arj 
rem   -i#      = com port irq number
rem   -l       = enable activity logging
rem   -n#      = limit temporary archive size to # kbytes
rem   -o#      = current node number where # is 0 to 999
rem   -p{tpath}= tpath = d:pathname of temporary directory to extract files to
rem   -q       = disable DesqView compability patch
rem   -r#      = baud rate for file transfer calculations
rem   -s{pwd}  = pwd = password required to shell to DOS
rem   -t#      = maximum number of minutes allowed in AViewCom
rem   -u       = update USERINFO.DAT to reflect downloads
rem   -v       = disable direct screen writes
rem   -w       = read user information from DOOR.SYS
rem   -x       = operate in Read (ASCII) Text mode instead of View Archive
rem   -z       = compensate for WildCat v3.02 reading user downloads
rem Options order is not important, but archive must come first
rem
rem  Note:  If you are running the shareware version, it will not read
rem  the port information from DOOR.SYS and therefore will not know if
rem  the caller is logging on locally.  To test AViewCom in the local
rem  mode, you will have to temporarily replace the COM parameter with LOCAL.
rem

rem
rem  Check if the WCNODEID environment variable is set.
rem
if "x%WCNODEID%" == "x" goto SingleNode

rem
rem  This is a multinode system, so we must CD to the node subdirectory
rem  If you are running a multi-node system, this directory is where the
rem  DOOR.SYS file is located for the current caller.  Also, a copy of the
rem  VIEWCOMP.BAT is copied to this directory from the main directory by
rem  wildcat.
rem
:MultiNode
cd \wc30\wcwork\node%WCNODEID%
if "x%WCPORTID%" == "x" goto NoPort

rem
rem  The rest of this SAMPLE batch file assumes you have installed AViewCom 
rem  in a directory called \WC30\AVIEWCOM\ so please change it as necessary.
rem

rem
rem  This calls aviewcom.  This is the same for single and multinode systems.
rem
:SingleNode
\wc30\aviewcom\aviewcom %1 com%WCPORTID% -w
goto end

rem
rem  This is called if the WCPORTID is not set.  This will use COM1.
rem
:NoPort
\wc30\aviewcom\aviewcom %1 com1 -w

:end
